﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

int main() {
	ll t; cin >> t;
	for (ll i = 0; i < t; ++i) {
		ll a, b, k, m;
		cin >> a >> b >> k >> m;
		// a * b - максимальное кол-во прямоугольников
		// a + b - 2 максимальное кол-во разрезов
		if (k > a + b - 2 || m > a * b) {
			cout << -1 << '\n';
		}
		else {
			//k = x + y
			//xy = m - k - 1
			ll pr = m - k - 1;
			ll d = sqrt(k * k - 4 * pr);
			if (pr < 0 || d * d != k * k - 4 * pr) {
				cout << -1 << '\n';
			}
			else {
				ll x = (k - d) / 2, y = (k + d) / 2;
				if (x + 1 <= a && y + 1 <= b) {
					cout << x << " " << y << '\n';
				}
				else if (x + 1 <= b && y + 1 <= a) {
					cout << y << " " << x << '\n';
				}
				else {
					cout << -1 << '\n';
				}
			}
		}
	}
	return 0;
}