﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
	ll t; cin >> t;
	vector<ll> f(2);
	f[0] = 1; f[1] = 1;
	while (f.back() < inf) {
		f.push_back(f.back() + f[f.size() - 2]);
	}
	for (ll i = 0; i < t; ++i) {
		ll n; cin >> n;
		map<ll, ll> v; v[n] = 1;
		set<ll> a = { n };
		ll cnt = 0;
		for (ll j = 2; j < f.size(); ++j) {
			set<ll> b;
			map<ll, ll> z;
			for (auto it = a.begin(); it != a.end(); ++it) {
				ll x = *it;
				b.insert(x);
				z[x] += v[x];
				while (x % f[j] == 0) {
					x /= f[j];
					if (x == 1) {
						cnt += v[*it];
					}
					else {
						b.insert(x);
						z[x] += v[*it];
					}
				}
			}
			a = b;
			v = z;
		}
		cout << cnt << '\n';
	}
	return 0;
}