﻿#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

int main() {
	ll n, q;
	cin >> n >> q;
	vector<ll> a(n);
	bool chek = true;
	for (ll i = 0; i < n; ++i) {
		cin >> a[i];
		if (i > 0) {
			if (a[i - 1] >= a[i]) {
				chek = false;
			}
		}
	}
	vector<ll> p(q), k(q);
	for (ll i = 0; i < q; ++i) {
		cin >> p[i] >> k[i];
		--p[i];
	}
	vector<ll> ans(q);
	map<ll, vector<pair<ll, ll>>> m;
	for (ll i = 0; i < q; ++i) {
		m[p[i]].push_back({ k[i], i });
	}
	for (auto it = m.begin(); it != m.end(); ++it) {
		sort(m[it->first].begin(), m[it->first].end());
	}
	if (chek) {
		for (ll i = 0; i < q; ++i) {
			ll cnt = 0;
			if (i + 1 == k[i]) {
				cnt += i + 1;
			}
			if (p[i] + k[i] - 1 <= n) {
				++cnt;
			}
			cout << cnt << '\n';
		}
	}
	else {
		for (ll j = 0; j < n; ++j) {// если первым ходом покрашен a[j] камень
			set<ll> pokr = { j };
			auto vv = m[j];
			vector<ll> v(vv.size());
			for (ll i = 0; i < vv.size(); ++i) {
				v[i] = vv[i].first;
			}
			for (ll h = lower_bound(v.begin(), v.end(), 1) - v.begin(); h < upper_bound(v.begin(), v.end(), 1) - v.begin(); ++h) {
				++ans[vv[h].second];
			}
			for (ll d = 2; d <= n; ++d) {// d действие
				ll now = n + 1, idx = n + 1;
				for (auto it = pokr.begin(); it != pokr.end(); ++it) {
					if (*it > 0) {
						if (now > a[*it - 1] && pokr.find(*it - 1) == pokr.end()) {
							now = a[*it - 1];
							idx = *it - 1;
						}
					}
					if (*it < n - 1) {
						if (now > a[*it + 1] && pokr.find(*it + 1) == pokr.end()) {
							now = a[*it + 1];
							idx = *it + 1;
						}
					}
				}
				pokr.insert(idx);
				auto vv = m[idx];
				vector<ll> v(vv.size());
				for (ll i = 0; i < vv.size(); ++i) {
					v[i] = vv[i].first;
				}
				for (ll h = lower_bound(v.begin(), v.end(), d) - v.begin(); h < upper_bound(v.begin(), v.end(), d) - v.begin(); ++h) {
					++ans[vv[h].second];
				}
			}
		}
		for (ll i = 0; i < q; ++i) {
			cout << ans[i] << '\n';
		}
	}
	return 0;
}