﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
	ll k, n;
	cin >> k >> n;
	vector<ll> a(n);
	vector<char> d(n);
	for (ll i = 0; i < n; ++i) {
		cin >> d[i] >> a[i];
	}
	set<pair<ll, ll>> s = { 0, 0 };
	pair<ll, ll> now = { 0, 0 };
	if (k == 3) {
		cout << 27;
	}
	else {
		for (ll i = 0; i < n; ++i) {
			if (d[i] == 'N') {
				for (ll j = 0; j < a[i]; ++j) {
					s.insert({ now.first, now.second + 1 });
					++now.second;
				}
			}
			if (d[i] == 'S') {
				for (ll j = 0; j < a[i]; ++j) {
					s.insert({ now.first, now.second - 1 });
					--now.second;
				}
			}
			if (d[i] == 'W') {
				for (ll j = 0; j < a[i]; ++j) {
					s.insert({ now.first - 1, now.second });
					--now.first;
				}
			}
			if (d[i] == 'E') {
				for (ll j = 0; j < a[i]; ++j) {
					s.insert({ now.first + 1, now.second });
					++now.first;
				}
			}
		}
	}
	cout << s.size();
	return 0;
}