﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

int main() {
	ll k, n;
	cin >> k >> n;
	vector<ll> a(n);
	vector<char> d(n);
	for (ll i = 0; i < n; ++i) {
		cin >> d[i] >> a[i];
	}
	set<pair<ll, ll>> s;
	s.insert({ 0, 0 });
	pair<ll, ll> now = { 0, 0 };
	for (ll i = 0; i < k; ++i) {
		for (ll j = 0; j < k; ++j) {
		     s.insert({ i, j });
		}
	}
	for (ll i = 0; i < n; ++i) {
		if (d[i] == 'N') {
			for (ll j = 0; j < a[i]; ++j) {
				++now.second;
				for (ll w = 0; w < k; ++w) {
					s.insert({ now.first + w, now.second + k - 1});
				}
			}
		}
		if (d[i] == 'S') {
			for (ll j = 0; j < a[i]; ++j) {
				--now.second;
				for (ll w = 0; w < k; ++w) {
					s.insert({ now.first + w, now.second });
				}
			}
		}
		if (d[i] == 'W') {
			for (ll j = 0; j < a[i]; ++j) {
				--now.first;
				for (ll w = 0; w < k; ++w) {
					s.insert({ now.first, now.second + w });
				}
			}
		}
		if (d[i] == 'E') {
			for (ll j = 0; j < a[i]; ++j) {
				++now.first;
				for (ll w = 0; w < k; ++w) {
					s.insert({ now.first + k - 1, now.second + w });
				}
			}
		}
	}
	cout << s.size();
	return 0;
}