﻿#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

const ll y = 1e12;

int main() {
	ll n, p;
	cin >> n >> p;
	vector<ll> z(n), a(n), b(n);
	ll cnt = 0;
	for (ll i = 0; i < n; ++i) {
		cin >> z[i] >> a[i] >> b[i];
		cnt += a[i];
	}
	ll l = 0/*сумма равна 0*/, r = y;
	while (r - l > 1) {
		ll x = (l + r) / 2;
		ll now = 0;
		for (ll i = 0; i < n; ++i) {
			if (x <= z[i]) {
				now += a[i] * x;
			}
			else {
				now += a[i] * z[i] + b[i] * (x - z[i]);
			}
		}
		if (p <= now) {
			r = x;
		}
		else {
			l = x;
		}
	}
	cout << r;

	return 0;
}